program TalkDat;
{$X+}
uses ufh_tlk;
const
 Extension = 'tab';
 ProgName = 'TALKDAT';
var
 key:     char;
 fInp:    file;
 fDat:    text;
 sInp,
 sOut:    string;
 i, n:    longint;
 Header:  tHeader;
 StrData: tStrData;

{ Return File name without file-extension}
function TruncExtension(sFileName: string): string;
 var
  sResult: string[8];
  i:       byte;
  nLength: byte;
  nShortl: byte;    {File name length without extension}
 begin
  sResult:='';
  nLength:= Length(sFileName);
  for i:=1 to nLength do
  begin
    if (sFileName[i] = '.') or (i = 9) then
    begin
      nShortl:= i-1;
      break;
    end;
  end;
  sResult:= Copy(sFileName, 1, nShortl);
  TruncExtension:= sResult;
 end;

Begin
 WriteLn('* * *');
 case ParamCount of
 0: begin
     WriteLn('Print: ',ProgName, ' dialog.tlk [output.',Extension,']');
     exit;
    end;
 1: begin
     sInp:= ParamStr(1);
     sOut:= TruncExtension(sInp)+'.'+Extension;
    end;
 else begin
     sInp:= ParamStr(1);
     sOut:= ParamStr(2);
    end;
 end;
 Assign(fInp, sInp);
 Assign(fDat, sOut);
{$I-}
 Reset(fInp, 1);
 if IOResult <> 0 then
 begin
   Writeln('Error. Unable to open file "', sInp,'"');
   halt(1);
 end;
{$I+}
 BlockRead(fInp, Header, SizeOf(Header));
 if (Header.FileType <> 'TLK ') or (Header.FileVer <> 'V3.0') then
  begin
    Writeln(' Error in "',sInp,'" file header!');
    Writeln(' This is not BioWare''s TLK 3.0 file or file is corrupted.');
    exit;
  end;
{$I-}
 Reset(fDat);
 if IOResult = 0 then
  begin
  WriteLn('Warning!');
    Write('File "',sOut,'" already exist. Overwrite it? (y/n)>');
  Repeat
   Read(Key);
   if key in ['N','n'] then exit;
  Until key in ['Y','y'];
 end;
 WriteLn;
{$I+}
 Rewrite(fDat);
 with Header do begin
  WriteLn('Input: ',sInp);
  WriteLn('  Size: ', FileSize(fInp),' bytes');
  WriteLn('  -= HEADER =-');
  WriteLn('  Format: ', FileType, FileVer);
  WriteLn('  Language ID: ', LangID);
  WriteLn('  String Count: ', StrCount);
  WriteLn('  Entries Offset: 0x',HexStr(StrEntr));

  N:= StrCount - 1;
 end; {with Header}
 WriteLn('Output: ',sOut);
 WriteLn;
 WriteLn('Run...');
 Write('Progress:   0 %');
               { 00001 12345678 12345678 12345 1234567812345678 }
  WriteLn(fDat, 'ID', #9, 'Flags', #9, 'Offset', #9, 'Size'#9, 'Sound', #9, 'Length');

  for i:=0 to Header.StrCount-1 do
  begin
   Seek(fInp, GetStrDataOfs(i));
   BlockRead(fInp, StrData, SizeOf(StrData));
   with StrData do begin
 {  Writeln('ID = ',i, '   Flags: ',HexStr(Flags), '   Offset: ',
    HexStr(StrOfs),'   StrSize:', StrSize,' or ', HexStr(StrSize)); }

    Write(fDat, i,
           #9, Flags,
           #9, HexStr(StrOfs),
           #9, StrSize:5);
    if SndFile[0] <> #0 then
      Write(fDat,#9, SndFile)
    else
      Write(fDat, #9, '***');
    WriteLn(fDat,#9, SndLeng:7:6);
   end; {with StrData}
   ShowProgress(i, N);
  end; {for i}
  WriteLn;
  Close(fInp);
  Close(fDat);
 WriteLn('Done.');
End.
