program TalkMix;
{  ⢫  ப (StrRef) }
{   tlk-䠩  ࣮.  ⠪ ꥤ  tlk  }
{ v 1.04 }

uses CRT, UFH_TLK;

const PROGNAME = 'TALKMIX';

type
  TMode = (INVALID, UPDATE, REPLACE);

  TFileTLK = record
    F: file;
    H: THeader;
  end;

var
 i, j:    longint;
 LowFile,
 UpFile,
 NewFile: TFileTLK;
 sLowName,
 sUpName,
 sNewName: string;

procedure FirstOpen(var Handle: TFileTLK; sName: string);
(*
 Assign file variable "f"  with "sName" file, open this file,
 check file format and print file header information.
*)
begin
 with Handle do begin
  {$I-}
   Assign(f, sName);
   Reset(f, 1);
   if IOResult<>0 then
   begin
    Writeln('ERROR! Can not open the file "',sName,'".');
    halt;
   end;
  {$I+}
  BlockRead(f, H, SizeOf(H));

  if (H.FileType <> 'TLK ') or (H.FileVer <> 'V3.0') then
  begin
    WriteLn('ERROR! Bad format or corrupted file.');
    halt;
  end;
  WriteLn('  Name: ', sName);
  WriteLn('  Size: ', FileSize(f),' bytes');
  WriteLn('  -= HEADER =-');
  WriteLn('  Format: ', H.FileType, H.FileVer);
  WriteLn('  Language ID: ', H.LangID);
  WriteLn('  String Count: ',H.StrCount);
  WriteLn('  Entries Offset: 0x',HexStr(H.StrEntr));
 end; {with Handle}
end;

function GetNewFile: string;
 const
  PREFIX = 'Mixed';
  MAX_IND = 99;
 var
  f: file;
  i: byte;
  sNum:  string[3];
  sName: string[15];
 begin
  sName:='';
{ if ParamCount>=3 then
  begin
   sName:=ParamStr(3);
   GetNewFile:=sName;
   exit;
  end; }
  {$I-}
  for i:=0 to MAX_IND do
  begin
   Str(i, sNum);
   sName:=PREFIX+sNum+'.tlk';
   Assign(f, sName);
   Reset(f, 1);
   if IOResult<>0 then break;
   close(f);
  end;
  GetNewFile:=sName;
  {$I+}
 end;{GetNewFile}

procedure ReplaceStrRef (var fBase, fExp: file; nStrID: dword);
(*********************************************************
   ப  ஬ nStrID  䠩 fBase  ப
   䠩 fExp  ⠪  ஬.
  ࠢ  ⮣  ਤ ९  䠩. 
   ⮬. 祣    ਤ㬠.
**********************************************************)
 var
  fNew: file;
  i, j: longint;
  hBase, hExp, hNew: tHeader; { 䠩}
  sNewFile: string;
 begin
  Reset(fBase, 1);
   BlockRead(fBase, hBase, SizeOf(hBase));
   hNew:=hBase;
   if hBase.StrCount < nStrID+1 then  {  䠩  ப  ஬ nStrID}
   begin
    Writeln('ERROR: Too high ID number!');
    halt;
   end;
   hNew.StrEntr:= GetStrDataOfs(hNew.StrCount);
   sNewFile:=GetNewFile;
   Assign(fNew, sNewFile);
  Rewrite(fNew, 1);
   BlockWrite(fNew, hNew, SizeOf(hNew));
  Close(fBase);
  Close(fNew);
   WriteLn(' Creating new file: ',sNewFile);
   Write(' Progress:   0 %');
   CopyStrRef(fBase, fNew, 0, nStrID);
   CopyStrRef(fExp, fNew, nStrID, 1);
   CopyStrRef(fBase, fNew, nStrID+1, hNew.StrCount-(nStrID+1));

 end;{of procedure}

(*
procedure ReplaceBlockStrRef (var fBase, fExp: file; nFrom, nTo: dword);
 var
  fNew:       file;
  i, j:       longint;
  nFirstID,
  nLastID:    dword;
  hBase,
  hExp, hNew: tHeader; { 䠩}
  StrData:    tStrData;
  sNewFile:   string;
 begin
  {஢塞   祭 nFrom  nTo   (0..$FFFFFF)}
  if (nFrom<0) or (nFrom>$FFFFFF)
  or (nTo < 0) or (nTo > $FFFFFF) then
  begin
   WriteLn('Incorrect Values!');
   exit;
  end
  {      ᫥}
  else if nFrom > nTo then
  begin
  {᫨ , 塞  ⠬}
   nFirstID:= nTo;
   nLastID:= nFrom;
  end else
  begin
   nFirstID:= nFrom;
   nLastID:= nTo;
  end;

  Reset(fBase, 1);
  Reset(fExp, 1);
   BlockRead(fBase, hBase, SizeOf(hBase));
   BlockRead(fExp, hExp, SizeOf(hBase));
   hNew:=hBase;
   if hBase.StrCount < nLastID then  {  䠩  ப  ஬ nStrID}
   begin
    if hExp.StrCount < nLastID then
    begin
     WriteLn('Incorrect values');
     exit;
    end;
    hNew.StrCount:= nLastID;
   end;
   hNew.StrEntr:= GetStrDataOfs(hNew.StrCount);
   sNewFile:=GetNewFile;
   Assign(fNew, sNewFile);
  Rewrite(fNew, 1);
   BlockWrite(fNew, hNew, SizeOf(hNew));
   { -, 㦭  ᤥ ஢,  塞   ப  ⥪⮬ }
   {  . }
  Close(fBase);
  Close(fExp);
  Close(fNew);
   WriteLn(' Creating new file: ',sNewFile);
   Write(' Progress:   0 %');
   CopyStrRef(fBase, fNew, 0, nFirstID);
   CopyStrRef(fExp, fNew, nFirstID, nLastID-nFirstID+1);
   CopyStrRef(fBase, fNew, nLastID+1, hNew.StrCount-(nLastID+1));

 end;{of procedure}
*)

procedure ReplaceBlock(var Base, Exp, New: TFileTLK; nFrom, nCount: longint);
var
 pHB, pHX, pHN: ^THeader; { 㪠⥫   䠩 }
 i, n: longint;
begin
 pHB:= @Base.H;
 pHX:= @Exp.H;
 pHN:= @New.H;
 n:= nFrom+nCount-1; {  ᫥ ப,   㤥 ஢ }
 if (pHX^.StrCount < n) then { ஢  㤠 }
 begin
   WriteLn(' Unable to copy string. Index out of range.');
   halt(1);
 end;
 pHN^:= pHB^;

 if (pHB^.StrCount < n) then
 { ᫥ ப  - ப   䠩}
 begin
   n:= n+1; {- ப}
   pHN^.StrCount:= n;
   pHN^.StrEntr:= GetStrDataOfs(n);
 end;
 BlockWrite(New.F, pHN^, HeaderSize);
 Close(New.F); { 뢠   }
 if (pHB^.StrCount <= nFrom) then
 begin
   { ७ᨬ ப  fBase }
   CopyStrRef(Base.F, New.F, 0, pHB^.StrCount);
   {  ⥯, 襬 ᪮쪮  ப }
   Reset(New.F, 1);
   for i:= pHB^.StrCount to nFrom-1 do
   begin
     seek(New.F, GetStrDataOfs(i));
     BlockWrite(New.F, DT_NULL, DTableSize);
   end;
   Close(New.F);
 end
 else CopyStrRef(Base.F, New.F, 0, nFrom);
 CopyStrRef(Exp.F, New.F, nFrom, nCount);
end;

{  䠩 (fBase) -  , ७ (fExp) -  孨
   , ᫥  ९   १ TFileTLK,
    - ⮬ :) }
procedure UpdateFile(var fBase, fExp, fNew: file);
 var
{ fNew:               file;}
  i, j:               longint;
  hBase, hExp, hNew:  tHeader;
  dBase, dExp, dNew:  tStrData;
  nDatPos:            dword;
  nID, nCount:        dword;
  sNewFile:           string;
 begin
  Reset(fBase,1);
  Reset(fExp, 1);
  BlockRead(fBase, hBase, SizeOf(hBase));
  BlockRead(fExp, hExp, SizeOf(hBase));
  Close(fBase);
  Close(fExp);
  if hExp.StrCount < hBase.StrCount then
   begin
    WriteLn('ERROR: Second file must have more strings then first');
    halt(1);
   end;
  { "ப" 䠩 ப  祬  "" -> 室}
{ sNewFile:=GetNewFile;
  Assign(fNew, sNewFile);
  Rewrite(fNew, 1); }
  hNew:=hExp;
  hNew.StrEntr:=GetStrDataOfs(hNew.StrCount);
  BlockWrite(fNew, hNew, SizeOf(hNew));
  Close(fNew);
  {Write(' Progress:   0 %');}
  for i:=0 to hBase.StrCount-1 do
  begin
   Reset(fBase,1);
   Reset(fExp, 1);
   nDatPos:=GetStrDataOfs(i);
   seek(fBase, nDatPos);
   seek(fExp,  nDatPos);
   BlockRead(fBase, dBase, SizeOf(dBase));
 {  BlockRead(fExp, dExp, sizeOf(dExp));}
   if (dBase.StrSize<>0) {or (dBase.SndFile[1]<>#0)} then
   {ப  ⥪}
     CopyStrRef(fBase, fNew, i, 1)
   else
   { ப?    㣮 䠩 ""?}
     CopyStrRef(fExp, fNew, i, 1);
  end; {for i:=0 to hBase.StrCount}
  { 襬 , 祣   䠩  뫮.}
  nID:=hBase.StrCount;
  nCount:= hNew.StrCount - hBase.StrCount;
  CopyStrRef(fExp, fNew, nID, nCount);
 end; {That's all, Folks!}

var
  sArg: string;    { ப  ࠡ⪨ 㬥  }
  bFlag: boolean;  { 䫠  祩   }
  nFiles: byte;    { 稪  䠩   }
  M: TMode;        { ० ࠡ ணࠬ, ।. 砬   }
  nRFrom,
  nRCount: longint;{ ࠬ   -R }
  iChr:    integer;{  訡 . Val }
Begin
  WriteLn(PROGNAME,': Talk Table File Mixer, v.1.04');
  WriteLn('Copirigt (c) 2003-2005, Friedrich');

 { ࠡ⪠ ࠬ஢ }
  bFlag:= FALSE;
  nFiles:= 0;
  M:= INVALID;
  for i:=1 to ParamCount do
  begin
    sArg:= ParamStr(i);
    if sArg[1] in ['/', '-'] then { ࠡ⪠ 祩 }
    begin
      if bFlag then {  ⮩ ணࠬ   ⮫쪮 }
      begin         {     ப }
        WriteLn('Only -U or -R<from>:<count> key is valid');
        halt(1);
      end;
      bFlag:= TRUE;
      if UpCase( sArg[2] ) = 'U' then
      begin
        M:= UPDATE;
      end {-U}
      else if UpCase( sArg[2] ) = 'R' then
      begin
        M:= REPLACE;
        j:= Pos(':', sArg);
        if (j = 0) then begin
          WriteLn(' Bad parameter ', ParamStr(i));
          halt(1);
        end;
        sArg:= Copy(sArg, 3, j-3);
        Val(sArg, nRFrom, iChr);
        if (iChr <> 0) then begin
          WriteLn(' Bad parameter ', ParamStr(i));
          halt(1);
        end;
        sArg:= ParamStr(i);
        sArg:= Copy(ParamStr(i), j+1, Length(ParamStr(i))-j);
        Val(sArg, nRCount, iChr);
        if (iChr <> 0) then begin
          WriteLn(' Bad parameter ', ParamStr(i));
          halt(1);
        end;
      end; {-R<from>:<count>}
    end { [-key]}
    else begin { ࠡ⪠  䠩 }
      inc(nFiles);
      case nFiles of
        1: sLowName:= ParamStr(i);
        2: sUpName:= ParamStr(i);
        3: sNewName:= ParamStr(i);
      end;
    end;
  end; {for i to ParamCount}
  if (bFlag = FALSE) then M:= UPDATE;
  if (nFiles < 2) then M:= INVALID else
  if (nFiles < 3) then sNewName:= GetNewFile;
  if M = INVALID then {   । }
  begin
   WriteLn(#10'Usage:  ',progname,' [-U|-R<from>:<count>] lowfile upfile [output]');
   WriteLn(' -U   (default)   = Update lowfile');
   WriteLn(' -R<from>:<count> = Replace some strings in "lowfile"');
   WriteLn(#10'Examples:');
   WriteLn(' ',ProgName,' lower.tlk upper.tlk');
   WriteLn(' ',ProgName,' -R100:200 lower.tlk upper.tlk');
   WriteLn(#10'Remarks:');
   WriteLn(' This program will create new file named by default as "MixedX.tlk".');
   WriteLn(' "Update lowfile" means that all strings that not exist in "lowfile"');
   WriteLn(' will be taken from "upfile". String Count of "upfile" must be higher');
   WriteLn(' than of "lowfile". (It is reason why this parameters called this way)');
(* WriteLn(' lower[0..99]    -> output');
   WriteLn(' upper[100..299] -> output');
   WriteLn(' lower[300..N]   -> output'); *)
   Write(' Press any key...');
   Repeat until KeyPressed;
   WriteLn(#10'Sorry, if my English wasn''t very good :)');
   halt(1);
  end;

  WriteLn('Lower File:');
  FirstOpen(LowFile, sLowName);
  WriteLn('Upper File:');
  FirstOpen(UpFile, sUpName);
  WriteLn('Output: ', sNewName);
  Assign(NewFile.F, sNewName);
  {$I-}
  Reset(NewFile.F, 1);
  if (IOResult = 0) then
     if AskYN('File "'+sNewName+'" already exist. Overwrite it? (Y/N)') = FALSE
     then halt;
  {$I+}
  Rewrite(NewFile.F, 1);
  case M of
    REPLACE: begin
      i:= nRFrom;
      j:= nRFrom + nRCount - 1;
      WriteLn(' Replacing strings from ', i,' to ', j);
      Write  (' Progress:');
      ReplaceBlock(LowFile, UpFile, NewFile, nRFrom, nRCount);
    end;
    UPDATE: begin
      WriteLn(' Concatenating files');
      Write  (' Progress:');
      UpdateFile(LowFile.F, UpFile.F, NewFile.F);
    end;
    else begin
      WriteLn('Something wrong!');
      halt(1);
    end;
  end; {of case}
  WriteLn;
  Write('Done. Press any key...');
  Repeat until KeyPressed;
  WriteLn(#10'Have a nice DOS. ;)');
End.