program TalkTex; {८ࠧ TLK 䠩  plane text ᮡ  :)}
uses
 UFH_TLK,
 U_ASCTLK;
const
 Ext = 'txt'; {The extension of result file}

{print error message and halt program}
procedure ErrorHalt(nErrID: byte);
begin
  case nErrID of
    1:   WriteLn('Error. Can not open input file.');
    10:  WriteLn('Error. Bad file format');
    11:  WriteLn('Error. Only TLK v3.0 (NWN) supported');
    else WriteLn('Error. Something wrong... Sorry.');
  end;
  halt(nErrID);
end;{of ErrorHalt}

{Return File name without file-extension}
function TruncExtension(sFileName: string): string;
 var
  sResult: string[8];
  i:       byte;
  nLength: byte;
  nShortl: byte;    {File name length without extension}
 begin
  sResult:='';
  nLength:= Length(sFileName);
  for i:=1 to nLength do
  begin
    if (sFileName[i] = '.') or (i = 9) then
    begin
      nShortl:= i-1;
      break;
    end;
  end;
  sResult:= Copy(sFileName, 1, nShortl);
  TruncExtension:= sResult;
 end;

Var {main}
 sInpName, sOutName: string;
 fInp: file; {TLK-file}
 fOut: text; {plain text result file}

 Header:  THeader;
 DTable:  TStrData;
 pText:   PChar;
 i, N:    longint;
 nTextPos,
 nDatPos: longint;
 key:     char;
{ bDone:   boolean;}

Begin
 WriteLn('* * *');
 {-= Determin names of files to work with =-}
 case ParamCount of
 0: begin
    WriteLn('TalkText: TLK to ASCII utility');
    WriteLn('(c) 2005, Friedrich');
    WriteLn;
    WriteLn('Usage: TALKTEXT dialog.tlk [outfile]');
    exit;
 (*  sInpName:= 'dialog.tlk';
     sOutName:= TruncExtension(sInpName)+'.'+Ext;}  *)
    end;
 1: begin
     sInpName:= ParamStr(1);
     sOutName:= TruncExtension(sInpName)+'.'+Ext;
    end;
 else begin
     sInpName:= ParamStr(1);
     sOutName:= ParamStr(2);
    end;
 end;

 {-= Openenig files =-}
 Assign(fInp, sInpName);
 Assign(fOut, sOutName);
 {$I-}
 Reset(fInp, 1);
 if IOResult <> 0 then ErrorHalt(1);

 {-= Reading file header and checking it =-}
 BlockRead(fInp, Header, HeaderSize);
 if Header.FileType <> 'TLK ' then ErrorHalt(10);
 if Header.FileVer  <> 'V3.0' then ErrorHalt(11);

 with Header do begin
  WriteLn('Input: ',sInpName);
  WriteLn('  Size: ', FileSize(fInp),' bytes');
  WriteLn('  -= HEADER =-');
  WriteLn('  Format: ', FileType,FileVer);
  WriteLn('  Language ID: ', LangID);
  WriteLn('  String Count: ', StrCount);
  WriteLn('  Entries Offset: 0x',HexStr(StrEntr));
 end; {with Header}

 { Check is the outfile exist }
 Reset(fOut);
 if IOResult = 0 then
 begin
  Write('File "',sOutName,'" already exist. Overwrite it? (y/n)>');
  Repeat
   Read(Key);
   if key in ['N','n'] then exit;
  Until key in ['Y','y'];
 end;
 {$I+}
 Rewrite(fOut);
 WriteLn('Output: ',sOutName);
 WriteLn;
 WriteLn('Run...');
 Write('Progress:   0 %');
 {-= Well, then we can start =-}
 {At first, write Header dats in fOut}
 Write(fOut, '@tlk',#10);
 with Header do
  Write(fOut, ';Header: ',FileType, FileVer,', lang ',LangID,', ',StrCount,' entries, ofs 0x',HexStr(StrEntr),#10);

 {-= , 㤥  ப  TLK  뢠   ⥪⮢ 䠩 =-}
 N:= Header.StrCount-1; { ᫥ ப}
 for i:=0 to N do
 begin
   ShowProgress(i, N);
   nDatPos:= GetStrDataOfs(i); {।塞  ⠡  i-⮩ ப}
   seek(fInp, nDatPos);       { 㤠}
   BlockRead(fInp, DTable, DTableSize); { ⠥}
   with DTable do begin
    if ((StrSize = 0) and (SndFile[0] = #0)) then continue;
    {᫨   ⥪  㪠, 祣   㤥}
    Write(fOut,#10); {⤥    ।饩}
    Write(fOut, '@',i,#10); {ਧ 砫  e.g.: @25}
    if SndFile[0] <> #0 then Write(fOut, '@sound ',SndFile,#10);
    if SndLeng <> 0.0   then Write(fOut, '@leng ', SndLeng:1:18,#10);

    nTextPos:= Header.StrEntr+DTable.StrOfs; { ⥪}
    seek(fInp, nTextPos);
    GetMem(pText, StrSize+1); {뤥塞   ⥪  0- }
    BlockRead(fInp, pText^, StrSize);
    pText[StrSize]:= #0;
    Write(fOut, pText,#10);
    FreeMem(pText, StrSize);

    Write(fOut, '@end',#10);
   end;{with DTable}
 end;{ <- for i}
 Write(fOut,';end of file');
 Close(fOut);
 Writeln;
 WriteLn('Done.');
End.

