program TalkComp;
{ணࠬ, ⭠ 'TalkTex'}
{८ࠧ ⥪ ᮡ   Bioware's Talk Table File (TLK 3.0 ;)}

{ 10.08.2005:
  ࠢ ஡,  ᫨  ᫥  室
  䠩 ॢ蠫 ࠧ  }

uses
 UFH_TLK,
 U_ASCTLK,
 Strings;

Var
 sInName, sOutName: string;
 fInText: text; {plain text}
 fInBin,        {use for binary accses to infile}
 fOutTlk: file; {TLK-file}

 Header:  THeader;
 DTable:  TStrData;

 zText: PChar;
 str:   string; {We need a pascal-style string as parametr for some subroutins}
 buf:   array[0..511] of char;
 i, j:  longint;
 k, l:  integer;
 nPos:  longint; {some offset in any file}
 key:   char;    {char for y/n checking}
 bDone: boolean; {flag in some loops or smth. like it}

{print error message and halt program}
procedure ErrorHalt(nErrID: byte);
begin
  Write('Error(',nErrID,'): ');
  case nErrID of
    1:   WriteLn('Can not open ',sInName,' file');
    2:   WriteLn('Wrong name of outfile');
    3:   Writeln('No "@tlk" at file header');
    else WriteLn('Something wrong... Sorry. :-(');
  end;
  ReadLn;
  halt(1);
end;{of ErrorHalt}

{Return File name without file-extension}
function TruncExtension(sFileName: string): string;
 var
  sResult: string[8];
  i:       byte;
  nLength: byte;
  nShortl: byte;    {File name length without extension}
 begin
  sResult:='';
  nLength:= Length(sFileName);
  for i:=1 to nLength do
  begin
    if (sFileName[i] = '.') or (i = 9) then
    begin
      nShortl:= i-1;
      break;
    end;
  end;
  sResult:= Copy(sFileName, 1, nShortl);
  TruncExtension:= sResult;
 end;

Begin
 WriteLn('TalkComp: TLK compiler, ASCII to TLK utility');
 WriteLn('Copyright (c) 2005, Friedrich');
 {-= Determin names of files to work with =-}
 case ParamCount of
 0: begin
     WriteLn;
     WriteLn('Usage: TALKCOMP source.txt [result.tlk]');
     exit;
    end;
 1: begin
     sInName:=  ParamStr(1);
     sOutName:= TruncExtension(sInName)+'.tlk';
    end;
 else begin
     sInName:=  ParamStr(1);
     sOutName:= ParamStr(2);
    end;
 end;

 {-= Openening files =-}
 Assign(fInText, sInName);
 Assign(fInBin, sInName);
 Assign(fOutTlk, sOutName);
 {$I-}
 Reset(fInText);
 if IOResult <> 0 then ErrorHalt(1);
 WriteLn('Input: ',sInName);

 if (sInName = sOutName) then
 begin
   ErrorHalt(2);
 end;

 Reset(fOutTLK); {Is it exist? We realy open it later}
 if IOResult = 0 then
 begin
  Write('File "',sOutName,'" already exist. Overwrite it? (y/n)>');
  Repeat
   ReadLn(Key);
   if key in ['N','n','',''] then exit;
  Until key in ['Y','y','',''];
 Close(fOutTlk);
 end;
 {$I+}

 {-= Make shure that we have right infile =-}
 Read(fInText, buf);{Cause we can't read a pointer we do so}
 zText:= @buf;
 zText[4]:=#0;
 str:= strPas(strLower(zText));
 if str <> '@tlk' then
   ErrorHalt(3);

 {Okay, it look like right format}
 Reset(fInBin, 1);{open infile as binary}

 {-= Look for the last string ID label =-}
 bDone:= False;
 i:= 0;
 Repeat
   inc(i);
   nPos:= FileSize(fInBin)- i*SizeOf(buf);
   if nPos < 0 then
   begin
     nPos:= 0;
   end;
   Seek(fInBin, nPos);
   BlockRead(fInBin, buf, SizeOf(buf), k);
  {for j:= SizeOf(buf)-1 downto 0 do}
   j:= k-1;
   while (not bDone) and (j > 0) do
   begin
     dec(j); {稭  ண    ᨢ}
     if buf[j] = '@' then
      begin
       if not(buf[j+1] in ['0'..'9']) then continue;
        {if next char isn't a digit, this @label isn't a StrRef ID}
       if not(buf[j-1] in [#10, #13]) then continue;
        {if this isn't new line, no @labels can be found here}

       {if there is new a line and there is a 'numeric' label (@xxx)}
       {maybe we can catch our ID?}
       zText:= @buf[j+1]; {pointer to @label}
       k:= 1; {Is the third nested loop bad?}
       while zText[k] in ['0'..'9'] do
       begin
         inc(k);
       end;
       zText[k]:= #0; {put null-terminator on end of StrRef ID @label}
       val(zText, Header.StrCount, l);
       inc(Header.StrCount);
       bDone:= TRUE;
      end
     else continue;

   end; {until bDone <- while (not bDone)}
   if (nPos = 0) and (bDone = FALSE) then
   {  ⨣ 砫 䠩  ⪠  ஬    }  
     ErrorHalt(4); { 室 䨣 - 10.08.05} 
 Until bDone;
{ Close(fInBin);}

 Rewrite(fOutTLK, 1);
 with Header do
  begin
    FileType:= 'TLK ';
    FileVer:= 'V3.0';
    LangID:= 0;
    StrEntr:= GetStrDataOfs(StrCount);
    WriteLn('Output: ',sOutName);
   {WriteLn('Expected size: ', );}
    WriteLn('  -= HEADER =-');
    WriteLn('  Format: ', FileType,FileVer);
    WriteLn('  Language ID: ', LangID);
    WriteLn('  String Count: ', StrCount);
    WriteLn('  Entries offset: 0x',HexStr(StrEntr));
  end;
 BlockWrite(fOutTLK, Header, HeaderSize);
 WriteLn('Starting Compilation.');
 WriteLn('String in process:');
 CompileTLK(fInBin, fOutTLK, Header);
 Writeln(#13#10'Done.');
End.