Unit ufh_tlk;
Interface
 const
  HeaderSize = 20; { . ⨯ THeader}
  DTableSize = 40; { . ⨯ TStrData}

 type
  dword = longint;  {32-bit Integer (4 byte)}
  float = single;   {32-bit floating point value (4 byte)}

  TResRef = array [0..15] of char;

  tHeader = record  {Header of tlk-file}
    FileType: array [1..4] of char; {'TLK '}
    FileVer:  array [1..4] of char; {'V3.0'}
    LangID:   dword;
    StrCount: dword;
    StrEntr:  dword;
    {⮣: 20 }
  end;

  tStrData = record  {  ப (String Data Table)}
    Flags:    dword;
    SndFile:TResRef; {array [0..15] of char;}
    Volume:   dword; {not used}
    Pitch:    dword; {  ,  ,  ⮦  ᯮ}
    StrOfs:   dword; { ࢮ   ப  砫 ⥪ StrRef'}
    StrSize:  dword; { ப (StrRef)  }
    SndLeng:  float; {த⥫쭮 砭 㪮 䠩, ᥪ.}
    {⮣: 40 }
  end;

 var { ६饭  U_ASCTLK }
  RS_NULL: TResRef;
  DT_NULL: TStrData;

 function GetStrDataOfs(nStrID: dword): dword;
 (*================================================================*
  頥   ⠡  ப  ஬ nStrID.
  *================================================================*)

 procedure CopyStrRef(var fBase, fNew: file; nFirstID, nCount: dword);
 (*================================================================*
   nCount ப 稭  ப  ஬ nFirstID
   䠩 fBase  䠩 fNew.
  *================================================================*)

 function HexStr(nInt: longint): string;
 (*================================================================*
  頥 ⭠  ᫠   ப
  *================================================================*)

 function AskYN(sAsk: string): boolean;
 (* 頥 TRUE ᫨     Y *)

 procedure ShowProgress(nCurr, nTotal: dword);
 (*================================================================*
  뢠 "ண"  業 - ᪮쪮 ப ᪮஢ 
  饣 ⢠ ப.
   nCurr  - current ID.
   nTotal - last ID.
  ᠭ ᪮ ,  ࠡ⠥.
  *================================================================*)

Implementation

Uses CRT;

const SavProg:  byte = 0; { . ShowProgress}
procedure ShowProgress(nCurr, nTotal: dword);
 var
  Prog: single;
 begin
  Prog:=((nCurr+1)/(nTotal+1))*100; {+1 to avoid division by zero}
  if Trunc(Prog)<>SavProg then
  begin
   GoToXY(12, WhereY);
   Write(Prog:3:0, ' %');
   SavProg:=Trunc(Prog);
  end;
 end;

function AskYN(sAsk: string): boolean;
var
 key: char;
 bResult: boolean;
begin
 Write(sAsk);
 Repeat
   key:= UpCase(ReadKey);
   if key = 'Y' then bResult:= TRUE else
   if key = 'N' then bResult:= FALSE;
 Until key in ['Y', 'N'];
 WriteLn(' ',key);
 AskYN:= bResult;
end;


function GetStrDataOfs(nStrID: dword): dword;
 begin
   GetStrDataOfs:= nStrID*DtableSize+HeaderSize;
 end;

function HexStr(nInt: longint): string;
 const
  HexChars: array [0..$F] of Char =
    '0123456789ABCDEF';
 var
  X:      longint;
  i, n:   integer;
  sResult: string;
 begin
  n:= SizeOf(X)*2;       {᫮ ᨬ  ப}
  X:=nInt;
  sResult[0]:= chr(n);
  for i:= n downto 1 do
  begin
   if odd(i) then
    begin  {i - ⭮: 7, 5, 3, 1}
     sResult[i]:= HexChars[Lo(x) shr 4];
     X:= X shr 8;
    end
   else    {i - ⭮: 8, 6, 4, 2}
    begin
     sResult[i]:= HexChars[Lo(x) and $0F];
    end;
  end;
  HexStr:=sResult;
 end;{HexStr}

procedure CopyStrRef(var fBase, fNew: file; nFirstID, nCount: dword);
 var
  i, j:        longint;  {६ 横  ..}
  nLastID:       dword;  { ᫥ ப,  ᫥ ஢}
  hBase, hNew: tHeader;  { 䠩}
  nDatPos:       dword;  {ࢠ  ⠡ }
  nPredStrEnd:   dword;  { ।. ப . ᫥饩}
  PredStrData,           {  ।饩 ப}
  StrData:    tStrData;  {... ⥪饩 ப   }
  {buf:           char;  {  ⮢ ஢ ⥪}
  pText:         PChar;

 begin
  Reset(fBase, 1);
  Reset(fNew, 1);
  BlockRead(fBase, hBase, HeaderSize);
  BlockRead(fNew, hNew, HeaderSize);
  nLastID:= nFirstID+nCount-1;
  nPredStrEnd:= -1; {祭  ।}
  for i:=nFirstID to nLastID do  {㥬    䠩}
   begin
   (**)
    ShowProgress(i, hNew.StrCount-1);
   (**)
    nDatPos:= GetStrDataOfs(i);
    seek(fBase, nDatPos);     {  砫 ⠡  i-⮩ ப }
    BlockRead(fBase, StrData, DTableSize);    {  ⠥ }
    with StrData do begin
     if StrSize<>0 then {StrRef  ⥪}
     begin
      Flags:=$01; {⥪ }
      Seek(fBase, StrOfs+hBase.StrEntr);  {  砫 ⥪ i-⮩ ப}
       {᫨ ப ࢠ (ID=0) }
       if i = 0 then StrOfs:= 0
       {  ࢠ ப . ⠬,  . । :)}
       else if nPredStrEnd <> -1 then StrOfs:= nPredStrEnd
       else
        begin
         Seek(fNew, GetStrDataOfs(i-1));
         BlockRead(fNew, PredStrData, DTableSize);
         j:=i-2;
        {᫨   ப   ⥪, ᬮਬ ।   ..}
        {।    0- ப  ⥪, ..:'Bad Strref'}
         while (PredStrData.StrSize = 0) and (j>=0) do
         begin
          Seek(fNew, GetStrDataOfs(j));
          BlockRead(fNew, PredStrData, DTableSize);
          j:=j-1;
         end;
         StrOfs:=PredStrData.StrOfs+PredStrData.StrSize;
       end; {if i=0... else  ..}
      {   砫 ⥪ ப   䠩, 筨 ,}
      {  室  砫: ;) }
      Seek(fNew, StrOfs+HNew.StrEntr);
      { 㥬 ⥪ ப: }
(*
       for j:=1 to StrSize do
       begin
        BlockRead(fBase, buf, 1);
        BlockWrite(fNew, buf, 1);
       end;
*)
      GetMem(pText, StrSize);
      BlockRead(fBase, pText^, StrSize);
      BlockWrite(fNew, pText^, StrSize);
      FreeMem(pText, StrSize);

      nPredStrEnd:= FilePos(fNew)-HNew.StrEntr; { 稫  ப}
     end  {"if StrSize<>0" (StrRef  ⥪)}
     else {StrRef   ⥪}
     begin
      Flags:= 0;
      StrOfs:=0; { "஢" ப  ⥪  0  ⮬ }
     end;

     if SndFile[0]<>#0 then {StrRef 易  㪮 䠩}
        Flags:= Flags or $06; {bin 110}

    end;  {"with StrData"}
    { 襬 ⠡ :}
    Seek(fNew, nDatPos);
    BlockWrite(fNew, StrData, DTableSize);
   end;{"for i:=nFirstID to nLastID"}
  Close(fBase);
  Close(fNew);
 end; {of procedure}

{ Initialization }
Var
 i: byte;
Begin
 for i:= 0 to High(TResRef) do RS_NULL[i]:= Chr(0);
 with DT_NULL do
 begin
   Flags  := 0;
   SndFile:= RS_NULL;
   Volume := 0;
   Pitch  := 0;
   StrOfs := 0;
   StrSize:= 0;
   SndLeng:= 0.0;
 end;
End.